"""
This program reads a DTD and produces a skeleton documentation file.

$Id: makeskel.py,v 1.2 2000/09/25 14:34:52 larsga Exp $
"""

import sys

import dddlib

# --- Utilities

def print_usage():
    print
    print "  makeskel.py dtdfile outputfile"
    print
    print "  Required arguments:"
    print "  dtdfile:    The DTD"
    print "  outputfile: Output destination"

# --- The program itself

def makeskel(dtdurl, outfile):
    dtd = dddlib.load_dtd(dtdurl)

    doco = dddlib.DTDDocumentation()
    for elem_name in dtd.get_elements():
        elem = dtd.get_elem(elem_name)
        elem_doco = dddlib.ElementDocumentation(elem_name)
        doco.elems[elem_name] = elem_doco

        for attr_name in elem.get_attr_list():
            elem_doco.add_attribute(dddlib.AttributeDocumentation(attr_name))

    dddlib.dump_dtddoc(outfile, doco)

def cmd_line():
    if len(sys.argv) != 3:
        print_usage()
        sys.exit(1)

    makeskel(sys.argv[1], sys.argv[2])

# --- Main program

if __name__ == "__main__":
    cmd_line()
